/**
	Paun Florin
	341C2
*/

/*
																															
			############	############	############	##########			####	   #########
			############	############	############	############		####	  #########
				###			####				####		####	####		 ##		 ####
				###			####				####		####	####		 ##		 #####
				###			############		####		############		 ##		   ######
				###			############		####		##########			 ##  	      ####
				###			####				####		########			 ##			 #####
				###			####				####		####  ###			 ##			 #####
				###			############		####		####  ###### 		####	  #####
				###			############		####		####	####		####	 ####
*/

#include <stdint.h>
#include <stdio.h>

#include <stdlib.h>
#include <string.h>

#include <avr/io.h>
#define F_CPU 16000000
#include <avr/pgmspace.h>
#include <util/delay.h>


#include "pcd8544.h"
#include "main.h"

#define USEDELAY 1

#define DIMMATGX 28
#define DIMMATGY 36
#define DIMMATX (DIMMATGY / 2)
#define DIMMATY (DIMMATGX / 2)


const unsigned char piese[5][3][3] = 
{
	{
		{1,1,0}, 
		{1,1,0}, 
		{0,0,0}
	},
	{
		{0,1,0}, 
		{1,1,0}, 
		{1,0,0}
	},
	{
		{1,0,0}, 
		{1,0,0}, 
		{1,1,0}
	},
	{
		{1,0,0}, 
		{1,1,0}, 
		{0,1,0}
	},
	{
		{0,1,0}, 
		{0,1,0}, 
		{1,1,0}
	}
};


// matricea cu elemente, am considerat ca un element e format din 4 pixeli
// 0 element liber/
// 1 piesa
// 2 bloc de piesa
// 3 border de matrice
unsigned char **a;	
//unsigned char a[DIMMATX][DIMMATY];
// pozitia piesei in matrice
unsigned char pozx;
unsigned char pozy;
//register unsigned char pozx asm("r3");
//register unsigned char pozy asm("r4");
// pozitia piesei curente pe lcd, 
unsigned char pgx;
unsigned char pgy;
// piesa curenta
unsigned char pnr;
// piesa poate fii mutata (CanMove)
unsigned char cm = 1;

int i;
int j;

/*
# Matrice pentru a, cum sunt retinute pisele in memorie
#		   y/--->	
#	 0 1 2 3 4 5 6 7 .. DIMMATY
#	0
#x	1
#|	2
#|	3
#|	4
#	5
#	6
#	7
#	.
#	.
#	DIMMATX

# Matrice pentru LCD, cum sunt afisate piesele
#		   x--->
#	 0 1 2 3 4 5 6 7 .. DIMMATGX
#	0
#y	1
#|	2
#|	3
#|	4
#	5
#	6
#	7
#	.
#	.
#	DIMMATGY
*/

void newPiess(unsigned char *cm) 
{
	pgx = DIMMATGX / 2; pgy = 2;
	pozx = 2; pozy = DIMMATY / 2;

	pnr = random() % 5;
	
	for ( i=0; i<3; i++)
		for ( j=0; j<3; j++) 
			a[pozx+i][pozy+j] = piese[pnr][i][j];	
	*cm = 1;
}

void drawElem(unsigned char x, unsigned char y) 
{
	LcdRect(x, x+2, y, y+2, 1);	
}

void drawP(unsigned char x, unsigned char y)
{
	drawElem(x, y);
	drawElem(x+2*1, y);
	drawElem(x, y+2*1);
	drawElem(x+2*1, y+2*1);
}

void drawZ1(unsigned char x, unsigned char y)
{
	drawElem(x+2*1, y);
	drawElem(x, y+2*1);
	drawElem(x+2*1, y+2*1);
	drawElem(x, y+2*2);
}

void drawZ2(unsigned char x, unsigned char y)
{
	drawElem(x, y);
	drawElem(x, y+2*1);
	drawElem(x+2*1, y+2*1);
	drawElem(x+2*1, y+2*2);
}

void drawL1(unsigned char x, unsigned char y)
{
	drawElem(x, y);
	drawElem(x, y+2*1);
	drawElem(x, y+2*2);
	drawElem(x+2*1, y+2*2);
}

void drawL2(unsigned char x, unsigned char y)
{
	drawElem(x+2*1, y);
	drawElem(x+2*1, y+2*1);
	drawElem(x, y+2*2);
	drawElem(x+2*1, y+2*2);
}

void drawPiess(unsigned char pnr, unsigned char pgx, unsigned char pgy)
{
	switch (pnr)
	{
		case 0:
			drawP(pgx, pgy);
			break;
		case 1:
			drawZ1(pgx, pgy);
			break;
		case 2:
			drawL1(pgx, pgy);
			break;
		case 3:
			drawZ2(pgx, pgy);
			break;
		case 4:
			drawL2(pgx, pgy);
			break;
		default:
			break;
	}
}

// deseneaza matricea pe lcd
void drawMatrix()
{
	for ( i=0; i<DIMMATX; i++)
		for ( j=0; j<DIMMATY; j++)
			if (a[i][j] != 0)
			{
				drawElem(j*2, i*2);			
			}
}

unsigned char inMat(int x, int y)
{
	if (x<=0)
		return 0;
	if (x>=DIMMATX-1)
		return 0;
	if (y<=0)
		return 0;
	if (y>=DIMMATY-1)
		return 0;
	return 1;
}

// verifica daca piesa poate fii mutata cu o unitate in jos
unsigned char canMovePiess()
{
	for (int i=DIMMATX-1-1; i>=1; i--)
		for ( j=1; j<DIMMATY-1; j++)
			if (a[i][j] == 1)
			{
				if (a[i+1][j] == 2)
					return 0;
				if (a[i+1][j] == 3)
					return 0;
			}
	return 1;
}

// verifica daca piesa poate fii mutata cu o unitate in jos
unsigned char canMovePiess2()
{
	for ( i=2; i>=0; i--)
		for ( j=0; j<3; j++)
		{
			if (inMat(pozx+i, pozy+j) == 1)
			{
				if (inMat(pozx+i+1, pozy+j) == 1)
				{
					if (a[pozx+i][pozy+j] == 1)
					{
						if (a[pozx+i+1][pozy+j] == 3)
							return 0;
						if (a[pozx+i+1][pozy+j] == 2)
							return 0;
					}
				}
			}
		}
	return 1;
}

// userul face o mutare la stanga sau la dreapta
void userMove(unsigned char dir)
{
	if (dir == 0) 
	{
		for ( i=1; i<DIMMATX-1; i++)
			for ( j=1; j<DIMMATY-1; j++) 
				if (a[i][j] == 1) {
					a[i][j-1] = 1;
					a[i][j] = 0;
				}
		pozy--;
	}
	if (dir == 1)
	{
		for ( i=1; i<DIMMATX-1; i++)
			for (int j=DIMMATY-1-1; j>0; j--)
				if (a[i][j] == 1) {
					a[i][j+1] = 1;
					a[i][j] = 0;
				}
		pozy++;
	}
}

// verifica daca utizatorul poate sa faca o mutare a stanga sau la dreapta
unsigned char userCanMove(unsigned char dir)
{
	if (dir == 0)
		for ( i=1; i<DIMMATX-1; i++)
			for ( j=1; j<DIMMATY-1; j++) 
				if (a[i][j] == 1)
				{
					if (a[i][j-1] == 2)
						return 0;
					if (a[i][j-1] == 3)
						return 0;
				}
	if (dir == 1)
		for ( i=1; i<DIMMATX-1; i++)
			for ( j=DIMMATY-1-1; j>0; j--)
				if (a[i][j] == 1)
				{
					if (a[i][j+1] == 2)
						return 0;
					if (a[i][j+1] == 3)
						return 0;
				}
	return 1;
}

// muta piesa cu o unitate in jos
void movePiess()
{
	for ( i=DIMMATX-1-1; i>=1; i--)
		for ( j=1; j<DIMMATY-1; j++)
			if (a[i][j] == 1) {
				a[i+1][j] = 1;
				a[i][j] = 0;
			}
	pozx++;
}

// muta piesa cu o unitate in jos
void movePiess2()
{
	for ( i=2; i>=0; i--)
		for ( j=0; j<3; j++)
		//if (inMat(pozx+i, pozy+j) == 1)
		//if (inMat(pozx+i+1, pozy+j) == 1)
			if (a[pozx+i][pozy+j] == 1) {
				a[pozx+i+1][pozy+j] = 1;
				a[pozx+i][pozy+j] = 0;
			}
	pozx++;		
}


// piesa a aterizat pe ceva solid, face piesa blocuri de piesa
void updateMatrix()
{
	for ( i=0; i<DIMMATX; i++)
		for ( j=0; j<DIMMATY; j++)
			if (a[i][j] == 1)
				a[i][j] = 2;
}

// piesa a aterizat pe ceva solid, face piesa blocuri de piesa
void updateMatrix2()
{
	for ( i=0; i<3; i++)
		for ( j=0; j<3; j++)
			if (inMat(pozx+i, pozy+j) == 1)
				if (a[pozx+i][pozy+j] == 1)
					a[pozx+i][pozy+j] = 2;
}


void initMatrix() 
{
	for ( i=0; i<DIMMATX; i++)
		for ( j=0; j<DIMMATY; j++)
			a[i][j] = 0;
}

// bordeaza matricea cu 3
void borderMatrix()
{
	for ( i=0; i<DIMMATX; i++) 
	{
		a[i][0] = 3;
		a[i][DIMMATY-1] = 3;
	}
	for ( j=0; j<DIMMATY; j++)
	{
		a[0][j] = 3;
		a[DIMMATX-1][j] = 3;
	}
}


int main()
{
	char m[8];

    LcdInit();

    //display image
    LcdContrast(0x7F);
    LcdClear();
    LcdImage(waitImage); 
    LcdUpdate();
	if (USEDELAY)
    _delay_ms(50);

    //display string
	LcdClear();
    LcdGotoXYFont(1,1);
	LcdFStr(FONT_1X,(unsigned char*)PSTR("    Tetris"));
	LcdGotoXYFont(1,4);
	LcdFStr(FONT_1X,(unsigned char*)PSTR("Paun Florin"));
	LcdGotoXYFont(1,5);
	LcdFStr(FONT_1X,(unsigned char*)PSTR("341C2"));
	LcdUpdate();
	if (USEDELAY)
	_delay_ms(50);

    LcdContrast(0x00);
    LcdUpdate();
	if (USEDELAY)
    _delay_ms(50);

	a = (unsigned char**)malloc(DIMMATX*sizeof(unsigned char*));
	for (unsigned char i=0; i<DIMMATX; i++) 
		a[i] = (unsigned char*)malloc(DIMMATY*sizeof(unsigned char));

	initMatrix();
	borderMatrix();

	DDRD = 0x00;//all pins as inputs
	//turn Pullups on
	PORTD=0xFF; 
	//daca a fost apasat unul dintre butoane
	
	newPiess(&cm);

	while (1) 
	{
		LcdClear();

		LcdLine(47, 47, 0, 47, 1);

		sprintf(m, "%d:%d", pgx, pgy);
		LcdGotoXYFont(10,1);
		LcdStr(FONT_1X,(byte*)m);	

		sprintf(m, "%d:%d", pozx, pozy);
		LcdGotoXYFont(10,2);
		LcdStr(FONT_1X,(byte*)m);	

		if( PIND != 0xFF)
		{
			if(PIND == 0xF7) //mutare stanga
			{
				if(pozy>=0)
				{
					if (userCanMove(0))
						userMove(0);
				}
			}
			if(PIND == 0xFD) //mutare dreapta
			{
				if(pozy<DIMMATY)
				{
					if (userCanMove(1))
						userMove(1);
				}
			}				
		}
		
		drawMatrix();
		
		cm = canMovePiess2();

		sprintf(m, "cm:%d", cm);
		LcdGotoXYFont(10,3);
		LcdStr(FONT_1X,(byte*)m);

		if (cm == 1)
		{
			movePiess();
		}
		else 
		{
			updateMatrix();
			drawMatrix();
			newPiess(&cm);
		}

		LcdUpdate();
		if (USEDELAY)
		_delay_ms(10);	
	}

    _delay_ms(50);

    return 0;
}

